#! /bin/sh

ip=/var/run/vpnc/keepalive-ip
keepalive=/var/run/vpnc/keepalive-pid
vpncpid=/var/run/vpnc/pid

op=$1
case $op in
    start)
	   logger -t $0 "START"
	   echo $$ > $keepalive

	   vpnc-connect

	   killall -HUP dnsmasq

	   PID="$(cat $vpncpid 2> /dev/null)"
	   IP="$(cat $ip 2> /dev/null)"

	   if [ -z "$IP" ]
	   then
	       logger -t $0 "no check ip found - exit"
	       exit 1
	   fi
	       
	   while [ 1 -eq 1 ]
	   do
	     logger -t $0 "connection - CHECK"
	     /bin/ping -c 1 $IP 2>&1 > /dev/null
	     if [ $? -ne 0 ] || ! kill -0 "$PID" 2>&1 >/dev/null
	     then
	       echo "vpnc connection lost - RESTART ..."
	       vpnc-disconnect
	       sleep 3
	       vpnc-connect
	       killall -HUP dnsmasq
	       PID="$(cat $vpncpid 2> /dev/null)"
	     fi
	     if kill -0 "$PID" 2>&1 >/dev/null
	     then
	       logger -t $0 "connection - OK"
	     else
	       logger -t $0 "connection - RETRY in 30s"
	     fi
	     sleep 30
	   done
	;;
    stop)
	  echo "$0 - STOP"
	  PID="$(cat $keepalive 2> /dev/null)"
	  if [ -z "$PID" ]; then
	    logger -t $0 "no $0 found running"
	    vpnc-disconnect
	    exit 1
	  fi
	  
	  if ! kill -0 "$PID" > /dev/null 2>&1; then
	    logger -t $0 "no $0 found running"
	    rm -f -- "$keepalive" 
	    vpnc-disconnect
	    exit 1
	  fi
	  kill $PID
	  rm -f -- "$keepalive" 
	  vpnc-disconnect
	;;
    *)
       # nothing
       ;;
esac

